/**
 * @license
 * Copyright 2023 Tyler Technologies, Inc. 
 * License: Apache-2.0
 */
import { ICustomElementFoundation } from '@tylertech/forge-core';
import { IListAdapter } from './list-adapter';
export interface IListFoundation extends ICustomElementFoundation {
    static: boolean;
    dense: boolean;
    propagateClick: boolean;
    indented: boolean;
    selectedValue: any;
}
/**
 * The foundation class behind the `<forge-list>` component.
 */
export declare class ListFoundation implements IListFoundation {
    private _adapter;
    private _static;
    private _dense;
    private _propagateClick;
    private _indented;
    private _selectedValue;
    private _keydownListener;
    constructor(_adapter: IListAdapter);
    initialize(): void;
    private _onKeydown;
    /**
     * Ensures that preventDefault is only called if the containing element doesn't
     * consume the event, and it will cause an unintended scroll.
     * @param {Event} evt
     */
    private _preventDefaultEvent;
    private _setSelectedValue;
    /** Gets/sets whether the list has all static items or not. */
    get static(): boolean;
    set static(value: boolean);
    /** Gets/sets whether the list has all dense items or not. */
    get dense(): boolean;
    set dense(value: boolean);
    get propagateClick(): boolean;
    set propagateClick(value: boolean);
    get indented(): boolean;
    set indented(value: boolean);
    get selectedValue(): any;
    set selectedValue(value: any);
}
